下面使用的API全是2019版本的API噢~~
开洞的方法是RevitAPI中直接提供的(如下图),里面一共有四个创建的重载方法。
1、给梁,柱子和撑杆来开洞的,现在也仅支持XYZ三个方向上的开洞。
2、给屋顶、楼板和天花板开洞,后面的bool属性,提供的是,是否垂直于所在面去开洞
3、在两个标高之间竖向开一个洞。
4、给墙体开洞
示例仅写了梁的开洞示例,如果大家有墙体开洞的需求可以在评论区告诉我,我再添加进去。
UIDocument uidoc = commandData.Application.ActiveUIDocument;
Document doc = uidoc.Document;
//选择一个构件
Reference selRef = uidoc.Selection.PickObject(Autodesk.Revit.UI.Selection.ObjectType.Element);
Element selElem = doc.GetElement(selRef);
XYZ pickPoint = selRef.GlobalPoint;
CurveArray cArr = CreateCurveArray(pickPoint);
Transaction openingTrans = new Transaction(doc, "开洞");
openingTrans.Start();
//梁上开口示范,柱子和撑杆上面统同理。这里需要注意后面的eRefFace需要和线组成的平面垂直
doc.Create.NewOpening(selElem, cArr, Autodesk.Revit.Creation.eRefFace.CenterZ);
openingTrans.Commit();
return Result.Succeeded;
private CurveArray CreateCurveArray(XYZ p)
{
CurveArray result = new CurveArray();
XYZ firstPoint = p;
XYZ secPoint = p.Add(XYZ.BasisY*100/304.8);
XYZ moveDir = XYZ.BasisX;
XYZ maxPoint = firstPoint.Add(moveDir * 100/304.8);
XYZ minPoint = secPoint.Add(moveDir * 100/304.8);
result.Append(Line.CreateBound(firstPoint, maxPoint));
result.Append(Line.CreateBound(maxPoint, minPoint));
result.Append(Line.CreateBound(minPoint, secPoint));
result.Append(Line.CreateBound(secPoint, firstPoint));
return result;
}
今天的分享就到这里,希望对你有所帮助。